#pragma once

#include <algorithm>

namespace AMDiS
{
  template <class InputIter, class T, class Func>
  void split(InputIter first, InputIter end, T const& t, Func f)
  {
    if (first == end)
      return;

    while (true) {
      InputIter found = std::find(first, end, t);
      f(first, found);
      if (found == end)
        break;
      first = ++found;
    }
  }

  template <class InputIter, class SeparaterIter, class Func>
  void split(InputIter first, InputIter end, SeparaterIter s_first, SeparaterIter s_end, Func f)
  {
    if (first == end)
      return;

    while (true) {
      InputIter found = std::find_first_of(first, end, s_first, s_end);
      f(first, found);
      if (found == end)
        break;
      first = ++found;
    }
  }
}