#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include "Solvers.hpp"

namespace Dune
{
  template class CGSolver<Precompiled::Vector>;
  template class GeneralizedPCGSolver<Precompiled::Vector>;
  template class BiCGSTABSolver<Precompiled::Vector>;
  template class MINRESSolver<Precompiled::Vector>;
  template class RestartedGMResSolver<Precompiled::Vector>;

#if DUNE_VERSION_GTE(DUNE_ISTL,2,7)
  template class RestartedFCGSolver<Precompiled::Vector>;
  template class CompleteFCGSolver<Precompiled::Vector>;
  template class RestartedFlexibleGMResSolver<Precompiled::Vector>;
#endif

#if HAVE_SUITESPARSE_UMFPACK
  template class UMFPack<Precompiled::Matrix>;
#endif

#if HAVE_SUITESPARSE_LDL
  template class LDL<Precompiled::Matrix>;
#endif

#if HAVE_SUITESPARSE_SPQR
  template class SPQR<Precompiled::Matrix>;
#endif

#if HAVE_SUITESPARSE_CHOLMOD && DUNE_VERSION_GTE(DUNE_ISTL,2,7)
  template class Cholmod<Precompiled::Vector>;
#endif

#if HAVE_SUPERLU && DUNE_VERSION_LT(DUNE_ISTL,2,7)
  template class SuperLU<Precompiled::Matrix>;
#endif

} // end namespace Dune
