#include "config.h"
#include <dune/grid/yaspgrid.hh>
#include <dune/grid/test/gridcheck.hh>

#include <amdis/AdaptiveGrid.hpp>

#include "Tests.hpp"

using namespace AMDiS;

// test IdentityGrid for given dimension
template <int dim>
void testDim()
{
  using HostGrid = Dune::YaspGrid<dim>;
  std::array<int,dim> n;
  std::fill(n.begin(), n.end(), 1 << (5 - dim));
  Dune::FieldVector<double,dim> extension(1.0);

  HostGrid grid(extension,n);
  grid.globalRefine(1);

  AdaptiveGrid<HostGrid> adaptiveGrid(grid);
  adaptiveGrid.globalRefine(1);

  gridcheck(adaptiveGrid);
}


int main(int argc, char** argv)
{
  Environment env(argc, argv);

  testDim<2>();
  testDim<3>();

  return report_errors();
}
