#include <amdis/AMDiS.hpp>
#include <amdis/common/Resize.hpp>

using namespace AMDiS;

struct Vec1 { void resize(std::size_t) {} };
struct Vec2 { void change_dim(std::size_t) {} };
struct Vec3
{
  void resize(std::size_t) {}
  void change_dim(std::size_t) {}
};

struct Mat1 { void resize(std::size_t,std::size_t) {} };
struct Mat2 { void change_dim(std::size_t,std::size_t) {} };
struct Mat3 { void setSize(std::size_t,std::size_t) {} };
struct Mat4
{
  void resize(std::size_t,std::size_t) {}
  void change_dim(std::size_t,std::size_t) {}
  void setSize(std::size_t,std::size_t) {}
};

struct NotResizable {};

int main(int argc, char** argv)
{
  Environment env(argc, argv);

  Vec1 vec1;
  Vec2 vec2;
  Vec3 vec3;

  resize(vec1, 1);
  resize(vec2, 1);
  resize(vec3, 1);

  static_assert(Concepts::VectorResizable_t<Vec1>::value, "");
  static_assert(Concepts::VectorResizable_t<Vec2>::value, "");
  static_assert(Concepts::VectorResizable_t<Vec3>::value, "");

  Mat1 mat1;
  Mat2 mat2;
  Mat3 mat3;
  Mat4 mat4;

  resize(mat1,1,1);
  resize(mat2,1,1);
  resize(mat3,1,1);
  resize(mat4,1,1);

  static_assert(Concepts::MatrixResizable_t<Mat1>::value, "");
  static_assert(Concepts::MatrixResizable_t<Mat2>::value, "");
  static_assert(Concepts::MatrixResizable_t<Mat3>::value, "");
  static_assert(Concepts::MatrixResizable_t<Mat4>::value, "");

  NotResizable notResizable;
  resize(notResizable,1);
  resize(notResizable,1,1);

  static_assert(not Concepts::VectorResizable_t<NotResizable>::value, "");
  static_assert(not Concepts::MatrixResizable_t<NotResizable>::value, "");

  return 0;
}
